/******************************************************************************
 *                                                                            *
 *  W[: DIB.C                                                         *
 *                                                                            *
 *  :       DIB郋[`                                         *
 *                                                                            *
 *  ֐:                                                                     *
 *                                                                            *
 *  OpenDIB()           - DIBt@CJăDIB쐬܂B          *
 *  WriteDIB()          - O[onhCF_DIB`Ńt@Cɏ  *
 *                        ܂B                                              *
 *  DibInfo()           - CF_DIB`̃ubNɊ֘AtĂ      *
 *                        ubN擾܂B                          *
 *  CreateBIPalette()   - BITMAPINFO\̂w|C^GDIpbg     *
 *                        쐬܂B                                        *
 *  CreateDibPalette()  - BITMAPINFO\̂̃nhGDIpbg쐬     *
 *                        ܂B                                            *
 *  ReadDibBitmapInfo() - DIB`̃t@CǂݎABITMAPINFO       *
 *                        O[onhԂ܂B                      *
 *  GetPaletteSize()       - w肳ꂽDIB̃pbg̃oCgvZ܂B     *
 *  GetDibNumColors()      - DIB̐F𔻒f܂B                             *
 *  BitmapFromDib()     - CF_DIB`̃ubNʂO[onh    *
 *                        ADDB쐬܂B                             *
 *  DibFromBitmap()     - nꂽDDBƓeDIB쐬܂B            *
 *  DrawBitmap()        - DC̎w肳ꂽʒuɃrbg}bv`悵܂B    *
 *  DibBlt()            - SetDIBitsToDevice()gāACIF_DIB`Ńrbg    *
 *                        }bv`悵܂B                                *
 *  StretchDibBlt()     - StretchDIBits()gāACIF_DIB`Ńrbg}bv  *
 *                        `悵܂B                                      *
 *  lread()             - 64KoCgȏǂݏo߂̃vCx[g[`   *
 *  lwrite()            - 64KoCgȏނ߂̃vCx[g[`   *
 *                                                                            *
 ******************************************************************************/

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "dib.h"

static   HCURSOR hcurSave;

/****************************************************************************
 *                                                                          *
 *  ֐:   OpenDIB(LPSTR szFile)                                           *
 *                                                                          *
 *  ړI:   DIBt@CJăDIB쐬܂B܂ABITMAPINFOA    *
 *          pbgf[^Arbg܂ރnh쐬܂B        *
 *                                                                          *
 *  ߂l: DIBʂnh                                           *
 *                                                                          *
 ****************************************************************************/
HANDLE OpenDIB (szFile)
LPSTR szFile;
{
    unsigned            fh;
    BITMAPINFOHEADER    bi;
    LPBITMAPINFOHEADER  lpbi;
    DWORD               dwLen = 0;
    DWORD               dwBits;
    HANDLE              hdib;
    HANDLE              h;
    OFSTRUCT            of;

    /* t@CJDIBǂݎ */
    fh = OpenFile(szFile, &of, OF_READ);
    if (fh == -1)
        return NULL;

    hdib = ReadDibBitmapInfo(fh);
    if (!hdib)
        return NULL;
    DibInfo(hdib,&bi);

    /* DIB̕ێɕKvȃʂvZ */
    dwBits = bi.biSizeImage;
    dwLen  = bi.biSize + (DWORD)GetPaletteSize (&bi) + dwBits;

    /* DIBێrbg}bvobt@TCY𑝂₷ */
    h = GlobalReAlloc(hdib, dwLen, GHND);
    if (!h){
        GlobalFree(hdib);
        hdib = NULL;
    }
    else
        hdib = h;

    /* rbgǂݎ */
    if (hdib){

        lpbi = (VOID FAR *)GlobalLock(hdib);
        lread(fh, (LPSTR)lpbi + (WORD)lpbi->biSize + GetPaletteSize(lpbi), dwBits);
        GlobalUnlock(hdib);
    }
    _lclose(fh);

    return hdib;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   OpenMemDIB(VOID)                                           *
 *                                                                          *
 *  ړI:   Nbv{[hDIB烁DIB쐬܂B܂ABITMAPINFOA    *
 *          pbgf[^Arbg܂ރnh쐬܂B        *
 *                                                                          *
 *  ߂l: DIBʂnh                                           *
 *                                                                          *
 ****************************************************************************/
HANDLE OpenMemDIB (HWND hWnd)
{
    LPBITMAPINFOHEADER  lpbi;
    DWORD	i, dwLen = 0;
	HANDLE	h = NULL, hbi = NULL;
	LPSTR	p;

    /* t@CJDIBǂݎ */
	if (! OpenClipboard(hWnd))
        return NULL;

	if ((h = GetClipboardData(CF_DIB)) == NULL)
		goto end;

	dwLen = (int)GlobalSize(h);
	if ((hbi = GlobalAlloc(GHND, dwLen)) == NULL)
		goto end;

	p = (LPSTR)GlobalLock(hbi);
	lpbi = (LPBITMAPINFOHEADER)GlobalLock(h);

	for (i = 0; i < dwLen;i++)
		*p++ = *((LPSTR)lpbi + i);

	GlobalUnlock(h);
	GlobalUnlock(hbi);

end:
	EmptyClipboard();
	CloseClipboard();
	return(hbi);
}

/****************************************************************************
 *                                                                          *
 *  ֐:   WriteDIB(LPSTR szFile,HANDLE hdib)                              *
 *                                                                          *
 *  ړI:   O[onhDF_DIB`Ńt@Cɏ݂܂B        *
 *                                                                          *
 *  ߂l: TRUE  - ɏIꍇ                                      *
 *          FALSE - ȊȌꍇ                                          *
 *                                                                          *
 ****************************************************************************/
BOOL WriteDIB (szFile, hdib)
LPSTR szFile;
HANDLE hdib;
{
    BITMAPFILEHEADER    hdr;
    LPBITMAPINFOHEADER  lpbi;
    int                 fh;
    OFSTRUCT            of;

    if (!hdib)
        return FALSE;

    fh = OpenFile (szFile, &of, OF_CREATE|OF_READWRITE);
    if (fh == -1)
        return FALSE;

    lpbi = (VOID FAR *)GlobalLock (hdib);

    /* t@Cwb_[̊eoݒ */
    hdr.bfType          = BFT_BITMAP;
    hdr.bfSize          = (int)GlobalSize (hdib) + sizeof (BITMAPFILEHEADER);
    hdr.bfReserved1     = 0;
    hdr.bfReserved2     = 0;
    hdr.bfOffBits       = (DWORD)sizeof(BITMAPFILEHEADER) + lpbi->biSize +
                          GetPaletteSize(lpbi);

    /* t@Cwb_[ */
    _lwrite (fh, (LPSTR)&hdr, sizeof (BITMAPFILEHEADER));

    /* DIBwb_[ƃrbg */
    lwrite (fh, (LPSTR)lpbi, (int)GlobalSize(hdib));

    GlobalUnlock (hdib);
    _lclose (fh);
    return TRUE;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   DibInfo(HANDLE hbi,LPBITMAPINFOHEADER lpbi)                     *
 *                                                                          *
 *  ړI:   CF_DIB`̃ubNɊ֘AtĂDIB         *
 *          擾܂B                                                    *
 *                                                                          *
 *  ߂l: TRUE  - ɏIꍇ                                      *
 *          FALSE - ȊȌꍇ                                          *
 *                                                                          *
 ****************************************************************************/
BOOL DibInfo (hbi, lpbi)
HANDLE hbi;
LPBITMAPINFOHEADER lpbi;
{
    if (hbi){
        *lpbi = *(LPBITMAPINFOHEADER)GlobalLock (hbi);

        /* ftHg̃oݒ */
        if (lpbi->biSize != sizeof (BITMAPCOREHEADER)){
            if (lpbi->biSizeImage == 0L)
                lpbi->biSizeImage =
                    WIDTHBYTES(lpbi->biWidth*lpbi->biBitCount) * lpbi->biHeight;

            if (lpbi->biClrUsed == 0L)
                lpbi->biClrUsed = GetDibNumColors (lpbi);
        }
        GlobalUnlock (hbi);
        return TRUE;
    }
    return FALSE;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   CreateBIPalette(LPBITMAPINFOHEADER lpbi)                        *
 *                                                                          *
 *  ړI:   BITMAPINFO\̂w|C^w肷ƁÃJ[e[u  *
 *          GDIpbgIuWFNg쐬܂B                       *
 *                                                                          *
 *  ߂l: pbgʂnh                                      *
 *                                                                          *
 ****************************************************************************/
HPALETTE CreateBIPalette (lpbi)
LPBITMAPINFOHEADER lpbi;
{
    LOGPALETTE          *pPal;
    HPALETTE            hpal = NULL;
    WORD                nNumColors;
    BYTE                red;
    BYTE                green;
    BYTE                blue;
    WORD                i;
    RGBQUAD        FAR *pRgb;

    if (!lpbi)
        return NULL;

    if (lpbi->biSize != sizeof(BITMAPINFOHEADER))
        return NULL;

    /* J[e[uw|C^ƐF擾 */
    pRgb = (RGBQUAD FAR *)((LPSTR)lpbi + (WORD)lpbi->biSize);
    nNumColors = GetDibNumColors(lpbi);

    if (nNumColors){
        /* _pbg\̂蓖Ă */
        pPal = (LOGPALETTE*)LocalAlloc(LPTR,sizeof(LOGPALETTE) + nNumColors * sizeof(PALETTEENTRY));
        if (!pPal)
            return NULL;

        pPal->palNumEntries = nNumColors;
        pPal->palVersion    = PALVERSION;

        /*
         * DIBJ[e[upbgGgݒ肵A
         * _J[pbg쐬
         */
        for (i = 0; i < nNumColors; i++){
            pPal->palPalEntry[i].peRed   = pRgb[i].rgbRed;
            pPal->palPalEntry[i].peGreen = pRgb[i].rgbGreen;
            pPal->palPalEntry[i].peBlue  = pRgb[i].rgbBlue;
            pPal->palPalEntry[i].peFlags = (BYTE)0;
        }
        hpal = CreatePalette(pPal);
        LocalFree((HANDLE)pPal);
    }
    else if (lpbi->biBitCount == 24){
        /* 
         * 24rbgDIBɂ̓J[e[uGgȂ߁A
         * ől(256)ݒ肷
         */
        nNumColors = MAXPALETTE;
        pPal = (LOGPALETTE*)LocalAlloc(LPTR,sizeof(LOGPALETTE) + nNumColors * sizeof(PALETTEENTRY));
        if (!pPal)
            return NULL;

        pPal->palNumEntries = nNumColors;
        pPal->palVersion    = PALVERSION;

        red = green = blue = 0;

        /* 
         * 256 (= 8*8*4)ʂRGB̑gݍ킹𐶐
         * pbgɐݒ肷
         */
        for (i = 0; i < pPal->palNumEntries; i++){
            pPal->palPalEntry[i].peRed   = red;
            pPal->palPalEntry[i].peGreen = green;
            pPal->palPalEntry[i].peBlue  = blue;
            pPal->palPalEntry[i].peFlags = (BYTE)0;

            if (!(red += 32))
                if (!(green += 32))
                    blue += 64;
        }
        hpal = CreatePalette(pPal);
        LocalFree((HANDLE)pPal);
    }
    return hpal;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   CreateDibPalette(HANDLE hbi)                                    *
 *                                                                          *
 *  ړI:   BITMAPINFO\̂wO[onhw肷ƁA      *
 *          J[e[uGDIpbgIuWFNg쐬܂B         *
 *          (BITMAPINFOHEADER`DIBp)                                 *
 *                                                                          *
 *  ߂l: pbgʂnh                                      *
 *                                                                          *
 ****************************************************************************/
HPALETTE CreateDibPalette (hbi)
HANDLE hbi;
{
    HPALETTE hpal;

    if (!hbi)
        return NULL;
    hpal = CreateBIPalette((LPBITMAPINFOHEADER)GlobalLock(hbi));
    GlobalUnlock(hbi);
    return hpal;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   ReadDibBitmapInfo(int fh)                                       *
 *                                                                          *
 *  ړI:   DIB`̃t@CǂݎABITMAPINFÕO[on     *
 *          hԂ܂B̊֐͈ȑO(BITMAPCOREHEADER)`ƐV    *
 *          BITMAPINFOHEADER)`̗ł܂AԂ̂͂     *
 *          ɐVBITMAPINFOłB                                        *
 *                                                                          *
 *  ߂l: t@CDIBBITMAPINFOʂnh                   *
 *                                                                          *
 ****************************************************************************/
HANDLE ReadDibBitmapInfo (fh)
int fh;
{
    DWORD     off;
    HANDLE    hbi = NULL;
    int       size;
    int       i;
    WORD      nNumColors;

    RGBQUAD FAR       *pRgb;
    BITMAPINFOHEADER   bi;
    BITMAPCOREHEADER   bc;
    LPBITMAPINFOHEADER lpbi;
    BITMAPFILEHEADER   bf;
    DWORD              dwWidth = 0;
    DWORD              dwHeight = 0;
    WORD               wPlanes, wBitCount;

    if (fh == -1)
        return NULL;

    /* t@C|C^ZbgAt@Cwb_[ǂݎ */
    off = _llseek(fh, 0L, SEEK_CUR);
    if (sizeof (bf) != _lread (fh, (LPSTR)&bf, sizeof (bf)))
        return FALSE;

    /* RCwb_[邩ׂ */
    if (!ISDIB (bf.bfType)) {
        bf.bfOffBits = 0L;
        _llseek (fh, off, SEEK_SET);
    }
    if (sizeof (bi) != _lread (fh, (LPSTR)&bi, sizeof(bi)))
        return FALSE;

    nNumColors = GetDibNumColors (&bi);

    /* 
     * ubN̓e(BITMAPINFO܂BITMAPCORE)`FbNA
     * ɏ]ď擾BBITMAPCOREHEADERȂ΁A
     * BITMAPINFOHEADER`̃ubNɓ]B
     */
    switch (size = (int)bi.biSize){
        case sizeof (BITMAPINFOHEADER):
            break;

        case sizeof (BITMAPCOREHEADER):

            bc = *(BITMAPCOREHEADER*)&bi;

            dwWidth   = (DWORD)bc.bcWidth;
            dwHeight  = (DWORD)bc.bcHeight;
            wPlanes   = bc.bcPlanes;
            wBitCount = bc.bcBitCount;

            bi.biSize               = sizeof(BITMAPINFOHEADER);
            bi.biWidth              = dwWidth;
            bi.biHeight             = dwHeight;
            bi.biPlanes             = wPlanes;
            bi.biBitCount           = wBitCount;

            bi.biCompression        = BI_RGB;
            bi.biSizeImage          = 0;
            bi.biXPelsPerMeter      = 0;
            bi.biYPelsPerMeter      = 0;
            bi.biClrUsed            = nNumColors;
            bi.biClrImportant       = nNumColors;

            _llseek (fh, (LONG)sizeof (BITMAPCOREHEADER) - sizeof (BITMAPINFOHEADER), SEEK_CUR);
            break;

        default:
            /* DIBł͂Ȃ */
            return NULL;
    }

    /* 0Ȃ΃ftHglݒ */
    if (bi.biSizeImage == 0){
        bi.biSizeImage = WIDTHBYTES ((DWORD)bi.biWidth * bi.biBitCount)
                         * bi.biHeight;
    }
    if (bi.biClrUsed == 0)
        bi.biClrUsed = GetDibNumColors(&bi);

    /* BITMAPINFO\̂ƃJ[e[u蓖Ă */
    hbi = GlobalAlloc (GHND, (LONG)bi.biSize + nNumColors * sizeof(RGBQUAD));
    if (!hbi)
        return NULL;
    lpbi = (VOID FAR *)GlobalLock (hbi);
    *lpbi = bi;

    /* J[e[uw|C^擾 */
    pRgb = (RGBQUAD FAR *)((LPSTR)lpbi + bi.biSize);
    if (nNumColors){
        if (size == sizeof(BITMAPCOREHEADER)){
            /*
             * ÂJ[e[u(3oCgRGBTRIPLE)VJ[e[
             * u(4oCgRGBQUAD)ɕϊ
             */
            _lread (fh, (LPSTR)pRgb, nNumColors * sizeof(RGBTRIPLE));

            for (i = nNumColors - 1; i >= 0; i--){
                RGBQUAD rgb;

                rgb.rgbRed      = ((RGBTRIPLE FAR *)pRgb)[i].rgbtRed;
                rgb.rgbBlue     = ((RGBTRIPLE FAR *)pRgb)[i].rgbtBlue;
                rgb.rgbGreen    = ((RGBTRIPLE FAR *)pRgb)[i].rgbtGreen;
                rgb.rgbReserved = (BYTE)0;

                pRgb[i] = rgb;
            }
        }
        else
            _lread(fh,(LPSTR)pRgb,nNumColors * sizeof(RGBQUAD));
    }

    if (bf.bfOffBits != 0L)
        _llseek(fh,off + bf.bfOffBits,SEEK_SET);

    GlobalUnlock(hbi);
    return hbi;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   GetPaletteSize(VOID FAR * pv)                                      *
 *                                                                          *
 *  ړI:   pbg̃oCgvZ܂BubNBITMAPCOREHEADER  *
 *          ^Ȃ΁AF3{pbgTCYɂȂ܂BȊȌꍇ   *
 *          ́AF4{pbgTCYɂȂ܂B                       *
 *                                                                          *
 *  ߂l: pbg̃oCg                                              *
 *                                                                          *
 ****************************************************************************/
WORD GetPaletteSize (pv)
VOID FAR * pv;
{
    LPBITMAPINFOHEADER lpbi;
    WORD               NumColors;

    lpbi      = (LPBITMAPINFOHEADER)pv;
    NumColors = GetDibNumColors(lpbi);

    if (lpbi->biSize == sizeof(BITMAPCOREHEADER))
        return NumColors * sizeof(RGBTRIPLE);
    else
        return NumColors * sizeof(RGBQUAD);
}

/****************************************************************************
 *                                                                          *
 *  ֐:   GetDibNumColorsByHandle(HANDLE h)                               *
 *                                                                          *
 *  ړI:   ubNBitCountoQƂāADIB̐F𔻒f܂B *
 *                                                                          *
 *  ߂l: DIB̐F                                                       *
 *                                                                          *
 ****************************************************************************/
WORD GetDibNumColorsByHandle(HANDLE h)
{
    LPBITMAPINFOHEADER  lpbi;
	WORD	n;


    lpbi = (LPBITMAPINFOHEADER)GlobalLock(h);
	n = GetDibNumColors((LPVOID)lpbi);
	GlobalUnlock(h);
	return(n);
}

/****************************************************************************
 *                                                                          *
 *  ֐:   GetDibNumColors(VOID FAR * pv)                                     *
 *                                                                          *
 *  ړI:   ubNBitCountoQƂāADIB̐F𔻒f܂B *
 *                                                                          *
 *  ߂l: DIB̐F                                                       *
 *                                                                          *
 ****************************************************************************/
WORD GetDibNumColors (pv)
VOID FAR * pv;
{
    int                 bits;
    LPBITMAPINFOHEADER  lpbi;
    LPBITMAPCOREHEADER  lpbc;

    lpbi = ((LPBITMAPINFOHEADER)pv);
    lpbc = ((LPBITMAPCOREHEADER)pv);

    /*
     *  BITMAPINFO`wb_[̏ꍇApbg̃TCYBITMAPCORE`
     *  wb_[biClrUsedĂBpbg̃TCÝAsNZ
     *  ̃rbgɂقȂB
     */
    if (lpbi->biSize != sizeof(BITMAPCOREHEADER)){
        if (lpbi->biClrUsed != 0)
            return (WORD)lpbi->biClrUsed;
        bits = lpbi->biBitCount;
    }
    else
        bits = lpbc->bcBitCount;

    switch (bits){
        case 1:                return 2;
        case 4:
                return 16;
        case 8:
                return 256;
        default:
                /* 24rbgDIBɂ̓J[e[u͂Ȃ */
                return 0;
    }
}
/****************************************************************************
 *                                                                          *
 *  ֐:   DibFromBitmap()                                                 *
 *                                                                          *
 *  ړI:   w肳ꂽDDB(foCXɈˑrbg}bv)ƓeDIB    *
 *          ܂ރO[oubN쐬܂B                    *
 *                                                                          *
 *  ߂l: DIBʂnh                                           *
 *                                                                          *
 ****************************************************************************/
HANDLE DibFromBitmap (HBITMAP hbm, DWORD biStyle, WORD biBits, HPALETTE hpal)
{
    BITMAP               bm;
    BITMAPINFOHEADER     bi;
    BITMAPINFOHEADER FAR *lpbi;
    DWORD                dwLen;
    HANDLE               hdib;
    HANDLE               h;
    HDC                  hdc;

    if (!hbm)
        return NULL;

    if (hpal == NULL)
        hpal = GetStockObject(DEFAULT_PALETTE);

    GetObject(hbm,sizeof(bm),(LPSTR)&bm);

    if (biBits == 0)
        biBits =  bm.bmPlanes * bm.bmBitsPixel;

    bi.biSize               = sizeof(BITMAPINFOHEADER);
    bi.biWidth              = bm.bmWidth;
    bi.biHeight             = bm.bmHeight;
    bi.biPlanes             = 1;
    bi.biBitCount           = biBits;
    bi.biCompression        = biStyle;
    bi.biSizeImage          = 0;
    bi.biXPelsPerMeter      = 0;
    bi.biYPelsPerMeter      = 0;
    bi.biClrUsed            = 0;
    bi.biClrImportant       = 0;

    dwLen  = bi.biSize + GetPaletteSize(&bi);

    hdc = GetDC(NULL);
    hpal = SelectPalette(hdc,hpal,FALSE);
         RealizePalette(hdc);

    hdib = GlobalAlloc(GHND,dwLen);

    if (!hdib){
        SelectPalette(hdc,hpal,FALSE);
        ReleaseDC(NULL,hdc);
        return NULL;
    }

    lpbi = (VOID FAR *)GlobalLock(hdib);

    *lpbi = bi;

    /* 
     *  lpBitsp[^NULLw肵GetDIBitsĂяoA
     *  biSizeImageovZ
     */
    GetDIBits(hdc, hbm, 0, (WORD)bi.biHeight,
        NULL, (LPBITMAPINFO)lpbi, DIB_RGB_COLORS);

    bi = *lpbi;
    GlobalUnlock(hdib);

    /* hCobiSizeImageoݒ肵Ȃꍇ͂ŕ₤ */
    if (bi.biSizeImage == 0){
        bi.biSizeImage = WIDTHBYTES((DWORD)bm.bmWidth * biBits) * bm.bmHeight;

        if (biStyle != BI_RGB)
            bi.biSizeImage = (bi.biSizeImage * 3) / 2;
    }

    /* rbgŜێ̂ɏ\ȑ傫̃obt@Ċ蓖Ă */
    dwLen = bi.biSize + GetPaletteSize(&bi) + bi.biSizeImage;
    if (h = GlobalReAlloc(hdib,dwLen,0))
        hdib = h;
    else{
        GlobalFree(hdib);
        hdib = NULL;

        SelectPalette(hdc,hpal,FALSE);
        ReleaseDC(NULL,hdc);
        return hdib;
    }
    /*
     * lpBitsp[^NULLȊO̒lݒ肵GetDIBitsĂяoA
     * ۂɃrbgf[^擾
     */
    lpbi = (VOID FAR *)GlobalLock(hdib);

    if (GetDIBits( hdc,
                   hbm,
                   0,
                   (WORD)bi.biHeight,
                   (LPSTR)lpbi + (WORD)lpbi->biSize + GetPaletteSize(lpbi),
                   (LPBITMAPINFO)lpbi, DIB_RGB_COLORS) == 0){
         GlobalUnlock(hdib);
         hdib = NULL;
         SelectPalette(hdc,hpal,FALSE);
         ReleaseDC(NULL,hdc);
         return NULL;
    }

    bi = *lpbi;
    GlobalUnlock(hdib);

    SelectPalette(hdc,hpal,FALSE);
    ReleaseDC(NULL,hdc);
    return hdib;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   BitmapFromDib(HANDLE hdib, HPALETTE hpal)                       *
 *                                                                          *
 *  ړI:   CF_DIB`̃ubÑO[onhw肷ƁA    *
 *          DDB (foCXɈˑȂrbg}bv)쐬܂B            *
 *                                                                          *
 *  ߂l: DDBʂnh                                           *
 *                                                                          *
 ****************************************************************************/
HBITMAP BitmapFromDib (HANDLE hdib, HPALETTE hpal)
{
    LPBITMAPINFOHEADER  lpbi;
    HPALETTE            hpalT;
    HDC                 hdc;
    HBITMAP             hbm;

    StartWait();

    if (!hdib)
        return NULL;

    lpbi = (VOID FAR *)GlobalLock(hdib);

    if (!lpbi)
        return NULL;

    hdc = GetDC(NULL);

    if (hpal){
        hpalT = SelectPalette(hdc,hpal,FALSE);
        RealizePalette(hdc);     // GDĨoO????
    }

    hbm = CreateDIBitmap(hdc,
                (LPBITMAPINFOHEADER)lpbi,
                (LONG)CBM_INIT,
                (LPSTR)lpbi + lpbi->biSize + GetPaletteSize(lpbi),
                (LPBITMAPINFO)lpbi,
                DIB_RGB_COLORS );

    if (hpal)
        SelectPalette(hdc,hpalT,FALSE);

    ReleaseDC(NULL,hdc);
    GlobalUnlock(hdib);

    EndWait();

    return hbm;
}
/****************************************************************************
 *                                                                          *
 *  ֐:   DrawBitmap(HDC hdc, int x, int y, HBITMAP hbm, DWORD rop)       *
 *                                                                          *
 *  ړI:   DChdc̎w肳ꂽʒuɃrbg}bvhbm`悵܂B        *
 *                                                                          *
 *  ߂l: BitBlt()̖߂l                                                *
 *                                                                          *
 ****************************************************************************/
BOOL DrawBitmap (hdc, x, y, hbm, rop)
HDC        hdc;
int        x, y;
HBITMAP    hbm;
DWORD      rop;
{
    HDC       hdcBits;
    BITMAP    bm;
    BOOL      f;

    if (!hdc || !hbm)
        return FALSE;

    hdcBits = CreateCompatibleDC(hdc);
    GetObject(hbm,sizeof(BITMAP),(LPSTR)&bm);
    SelectObject(hdcBits,hbm);
    f = BitBlt(hdc,0,0,bm.bmWidth,bm.bmHeight,hdcBits,0,0,rop);
    DeleteDC(hdcBits);

    return f;
}
/****************************************************************************
 *                                                                          *
 *  ֐:  DibBlt( HDC hdc,                                                 *
 *                 int x0, int y0,                                          *
 *                 int dx, int dy,                                          *
 *                 HANDLE hdib,                                             *
 *                 int x1, int y1,                                          *
 *                 LONG rop)                                                *
 *                                                                          *
 *  ړI:   SetDIBitsToDevicegāACF_DIB`̃rbg}bv`       *
 *          ܂BBitBltƓp[^܂B                      *
 *                                                                          *
 *  ߂l: TRUE  - ɏIꍇ                                      *
 *          FALSE - ȊȌꍇ                                          *
 *                                                                          *
 ****************************************************************************/
BOOL DibBlt (hdc, x0, y0, dx, dy, hdib, x1, y1, rop)
HDC        hdc;
int        x0, y0, dx, dy;
HANDLE     hdib;
int        x1, y1;
LONG       rop;
{
    LPBITMAPINFOHEADER   lpbi;
    LPSTR                pBuf;

    if (!hdib)
        return PatBlt(hdc,x0,y0,dx,dy,rop);

    lpbi = (VOID FAR *)GlobalLock(hdib);

    if (!lpbi)
        return FALSE;

    pBuf = (LPSTR)lpbi + (WORD)lpbi->biSize + GetPaletteSize(lpbi);
    SetDIBitsToDevice (hdc, x0, y0, dx, dy,
                       x1,y1,
                       x1,
                       dy,
                       pBuf, (LPBITMAPINFO)lpbi,
                       DIB_RGB_COLORS );

    GlobalUnlock(hdib);
    return TRUE;
}
/****************************************************************************
 *                                                                          *
 *  ֐:   StretchDibBlt( HDC hdc,                                         *
 *                         int x, int y,                                    *
 *                         int dx, int dy,                                  *
 *                         HANDLE hdib,                                     *
 *                         int x0, int y0,                                  *
 *                         int dx0, int dy0,                                *
 *                         LONG rop)                                        *
 *                                                                          *
 *  ړI:   StrechDIBits()gāACF_DIB`̃rbg}bv`悵܂B  *
 *          StretchBlt()Ɠp[^܂B                        *
 *                                                                          *
 *  ߂l: TRUE  - ɏIꍇ                                      *
 *          FALSE - ȊȌꍇ                                          *
 *                                                                          *
 ****************************************************************************/
BOOL StretchDibBlt (hdc, x, y, dx, dy, hdib, x0, y0, dx0, dy0, rop)
HDC hdc;
int x, y;
int dx, dy;
HANDLE hdib;
int x0, y0;
int dx0, dy0;
LONG rop;

{
    LPBITMAPINFOHEADER lpbi;
    LPSTR        pBuf;
    BOOL         f;

    if (!hdib)
        return PatBlt(hdc,x,y,dx,dy,rop);

    lpbi = (VOID FAR *)GlobalLock(hdib);

    if (!lpbi)
        return FALSE;

    pBuf = (LPSTR)lpbi + (WORD)lpbi->biSize + GetPaletteSize(lpbi);

    f = StretchDIBits ( hdc,
                        x, y,
                        dx, dy,
                        x0, y0,
                        dx0, dy0,
                        pBuf, (LPBITMAPINFO)lpbi,
                        DIB_RGB_COLORS,
                        rop);

    GlobalUnlock(hdib);
    return f;
}

 /********** 64KoCgȏ̓ǂݏsvCx[g[` ************/
/****************************************************************************
 *                                                                          *
 *  ֐:   lread(int fh, VOID FAR *pv, DWORD ul)                           *
 *                                                                          *
 *  ړI:   f[^ׂēǂݎ܂32KoCgf[^ǂݎ܂B   *
 *                                                                          *
 *  ߂l: 0                  - ɓǂݎȂꍇ                 *
 *          ǂݎoCg - ȊȌꍇ                             *
 *                                                                          *
 ****************************************************************************/
DWORD PASCAL lread (fh, pv, ul)
int           fh;
VOID far      *pv;
DWORD         ul;
{
    DWORD     ulT = ul;
    BYTE	*hp = pv;

    while (ul > (DWORD)MAXREAD) {
        if (_lread(fh, (LPSTR)hp, (WORD)MAXREAD) != MAXREAD)
                return 0;
        ul -= MAXREAD;
        hp += MAXREAD;
    }
    if (_lread(fh, (LPSTR)hp, (WORD)ul) != (WORD)ul)
        return 0;
    return ulT;
}

/****************************************************************************
 *                                                                          *
 *  ֐:   lwrite(int fh, VOID FAR *pv, DWORD ul)                          *
 *                                                                          *
 *  ړI:   f[^ׂďނ܂32KoCgf[^݂܂B   *
 *                                                                          *
 *  ߂l: 0                  - ɏ߂Ȃꍇ                 *
 *          񂾃oCg - ȊȌꍇ                             *
 *                                                                          *
 ****************************************************************************/
DWORD PASCAL lwrite (fh, pv, ul)
int          fh;
VOID FAR     *pv;
DWORD        ul;
{
    DWORD     ulT = ul;
    BYTE	*hp = pv;

    while (ul > MAXREAD) {
        if (_lwrite(fh, (LPSTR)hp, (WORD)MAXREAD) != MAXREAD)
                return 0;
        ul -= MAXREAD;
        hp += MAXREAD;
    }
    if (_lwrite(fh, (LPSTR)hp, (WORD)ul) != (WORD)ul)
        return 0;
    return ulT;
}
